package org.jeecg.modules.ctop.controller;

import cn.com.ctop.bytedance.entity.BytedancePlanDailyReport;
import cn.com.ctop.bytedance.service.IBytedancePlanDailyReportService;
import cn.com.ctop.bytedance.service.IBytedancePlanHourlyReportService;
import cn.com.ctop.bytedance.service.IReportService;
import cn.com.ctop.common.module.entity.CtopOauthToken;
import cn.com.ctop.common.module.entity.UserAllocation;
import cn.com.ctop.common.module.mapper.CtopOauthTokenMapper;
import cn.com.ctop.common.module.service.ICtopOauthTokenService;
import cn.com.ctop.common.module.service.IUserAllocationService;
import cn.com.ctop.common.module.utils.Check;
import cn.com.ctop.common.module.utils.CtopAdConstant;
import cn.com.ctop.common.module.utils.ResultMapUtils;
import cn.com.ctop.common.module.utils.StatusCode;
import cn.com.ctop.kuaishou.modules.batch.entity.KuaiShouCampaign;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaiShouCampaignService;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaiShouDailyReportTaskService;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaiShouHistoryReportTaskService;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaishouInterfaceService;
import cn.com.ctop.kuaishou.modules.graphql.service.IKuaishouWebInterfaceService;
import cn.com.ctop.kuaishou.modules.report.mapper.KuaishouReportDailyCreativeMapper;
import cn.com.ctop.kuaishou.modules.report.mapper.KuaishouReportDailyCreativeStatisticMapper;
import cn.com.ctop.toutiao.service.IByteDanceAdvertiserDataService;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.util.DateUtils;
import org.jeecg.modules.ctop.service.ICleanMaterialService;
import org.jeecg.modules.ctop.service.ICreateInternalService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import static org.jeecg.common.util.DateUtils.getAnotherDay;

/**
 * @author jeecg-boot
 */
@RestController
@RequestMapping("/test")
@Slf4j
public class TestController {
    @Autowired
    private ICreateInternalService createInternalService;
    @Autowired
    private IKuaishouWebInterfaceService kuaishouWebInterfaceService;

    @Autowired
    private CtopOauthTokenMapper oauthTokenMapper;
    @Autowired
    private IKuaiShouHistoryReportTaskService historyReportTaskService;

    @PostMapping(value = "/create")
    public Map<String, Object> authorization(@RequestBody JSONObject jsonObject) {
        return createInternalService.createInternal(jsonObject);
    }

    @GetMapping(value = "/t")
    public String test() {
        Result<String> result = new Result<String>();
        try {
            String requestId = UUID.randomUUID().toString();
            String img = kuaishouWebInterfaceService.qrLogin(requestId);
            if (img != null) {
                result.setSuccess(true);
                result.setResult(img);
            } else {
                result.setSuccess(false);
            }
        } catch (Exception e) {
            e.printStackTrace();
            result.setSuccess(false);
        }
        return "success";
    }


    @Autowired
    private CtopOauthTokenMapper tokenMapper;
    @Autowired
    private IKuaishouInterfaceService kuaishouInterfaceService;



    @GetMapping(value = "/getHistoryData")
    public String getHistoryData() {
        Result<String> result = new Result<String>();
        try {
            String endDateStr = DateUtils.getDate("yyyy-MM-dd");
            String startDate = DateUtils.addMonth(endDateStr, -6);
            QueryWrapper<CtopOauthToken> tokenQueryWrapper = new QueryWrapper<>();
            tokenQueryWrapper.eq("media_id", 2);
            System.err.println(startDate);
            System.err.println(endDateStr);


            List<CtopOauthToken> ctopOauthTokens = oauthTokenMapper.selectList(tokenQueryWrapper);
            if (!Check.isNull(ctopOauthTokens)) {
                for (CtopOauthToken token : ctopOauthTokens) {
                    historyReportTaskService.createTask(token.getAccountId(), token.getAccessToken(), startDate, endDateStr, CtopAdConstant.KUAISHOU_LOAD_JOB_TYPE_HISTORY);
                }

            }
        } catch (Exception e) {
            e.printStackTrace();
            result.setSuccess(false);
        }
        return "success";
    }


    @GetMapping(value = "/getTaskList")
    public String getTaskList() {
        Result<String> result = new Result<String>();
        try {
            String endDateStr = DateUtils.getDate("yyyy-MM-dd");
            String startDate = DateUtils.addMonth(endDateStr, -6);
            QueryWrapper<CtopOauthToken> tokenQueryWrapper = new QueryWrapper<>();
            tokenQueryWrapper.eq("media_id", 2);
            System.err.println(startDate);
            System.err.println(endDateStr);


            historyReportTaskService.getTaskList();


        } catch (Exception e) {
            e.printStackTrace();
            result.setSuccess(false);
        }
        return "success";
    }

    @GetMapping(value = "/getGroupData")
    public String getGroupData() {


        Date endDate = new Date();
        QueryWrapper<CtopOauthToken> tokenQueryWrapper = new QueryWrapper<>();
        tokenQueryWrapper.eq("media_id", 2);
        List<CtopOauthToken> ctopOauthTokens = tokenMapper.selectList(tokenQueryWrapper);
        for (CtopOauthToken token : ctopOauthTokens) {


            for (int i = 0; i < 7; i++) {
                Date getStartDate = DateUtils.addDay(endDate, -i);
                //3：获取广告组信息数据
                kuaishouInterfaceService.getAdvertiserGroupReportHourly(token, getStartDate, getStartDate);
            }
            for (int i = 0; i < 6; i++) {
                Date getStartDate = new Date();
                Date getEndDate = new Date();
                if (i == 0) {
                    getStartDate = DateUtils.addDay(endDate, -175 + i * 30);
                    getEndDate = DateUtils.addDay(endDate, -150 + i * 30);
                } else {
                    getStartDate = DateUtils.addDay(endDate, -180 + i * 30);
                    getEndDate = DateUtils.addDay(endDate, -150 + i * 30);
                }
                //3：获取广告组信息数据
                kuaishouInterfaceService.getAdvertiserGroupReportDaily(token, getStartDate, getEndDate);
            }
        }
        return "Success";
    }

    static ExecutorService executorService = Executors.newFixedThreadPool(5);

    @GetMapping(value = "/getVideoAndImage")
    public String getVideoAndImage() {
        QueryWrapper<CtopOauthToken> tokenQueryWrapper = new QueryWrapper<>();
        tokenQueryWrapper.eq("media_id", 2);
        List<CtopOauthToken> ctopOauthTokens = tokenMapper.selectList(tokenQueryWrapper);
        for (CtopOauthToken token : ctopOauthTokens) {
            executorService.submit(new Runnable() {
                @Override
                public void run() {
                    kuaishouInterfaceService.getVideoList2(token, null, null, 1);
                    kuaishouInterfaceService.getImageList2(token, null, null, 1);
                    //   kuaishouInterfaceService.getCreativeList2(token, null, null, 1);
                }
            });

        }
        return "Success";
    }


    @GetMapping(value = "/gerCreative")
    public void gerCreative() {
        QueryWrapper<CtopOauthToken> oauthTokenQueryWrapper = new QueryWrapper<>();
        oauthTokenQueryWrapper.eq("media_id", 2);
        List<CtopOauthToken> ctopOauthTokens = oauthTokenMapper.selectList(oauthTokenQueryWrapper);
        for (CtopOauthToken token : ctopOauthTokens) {
            executorService.submit(new Runnable() {
                @Override
                public void run() {
                    try {
                        System.err.println("获取创意,accountId:" + token.getAccountId());
                        kuaishouInterfaceService.getCreativeList(token, null, null);
                        //  kuaishouInterfaceService.getVideoList2(token, null, null,1);
                        //3: 获取图片信息数据
                        // kuaishouInterfaceService.getImageList2(token, null, null,1);
                        Thread.sleep(1 * 200);
                        //  kuaishouInterfaceService.getAppList(token.getAccountId(), token.getAccessToken());
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            });
        }

    }

    @GetMapping("checkFile")
    public Map<String, Object> checkFile() {
        String nowDate = DateUtils.getDate("yyyy-MM-dd");
        String statDate = getAnotherDay("yyyy-MM-dd", nowDate, -1);
        //  查询快手token
        List<CtopOauthToken> tokens = tokenService.getTokenListByType(CtopAdConstant.PLATFORM_TYPE_KUAISHOU);
        if (null == tokens || tokens.size() <= 0) {
            log.info("定时获取快手数据异常：未获取到可用的token");
        }
        for (CtopOauthToken token : tokens) {
            dailyReportTaskService.getTaskList(token.getAccountId(), token.getAccessToken(), statDate);
        }
        Map<String, Object> result = new HashMap<>();
        ResultMapUtils.setResultMap(result, StatusCode.COMMON_SUCCESS);
        return result;
    }

    @Autowired
    private IKuaiShouDailyReportTaskService dailyReportTaskService;


    @Autowired
    private IKuaiShouCampaignService campaignService;

    @GetMapping(value = "/getCreativeReportByAccount")
    public void gerCreativeReportByAccount(Long accountId, String startDateStr, String endDateStr) {
        Thread thread = new Thread() {
            @SneakyThrows
            @Override
            public void run() {
                SimpleDateFormat sim = new SimpleDateFormat("yyyy-MM-dd");
                Date startDate = sim.parse(startDateStr);
                Date endDate = sim.parse(endDateStr);
                //1:查询当日数据
                //executorService = Executors.newFixedThreadPool(3);
                QueryWrapper<CtopOauthToken> oauthTokenQueryWrapper = new QueryWrapper<>();
                oauthTokenQueryWrapper.eq("media_id", 2);
                oauthTokenQueryWrapper.eq("account_id", accountId);
                CtopOauthToken ctopOauthToken = oauthTokenMapper.selectOne(oauthTokenQueryWrapper);

                System.err.println("创意报表accountId:" + ctopOauthToken.getAccountId());
                QueryWrapper<KuaiShouCampaign> campaignQueryWrapper = new QueryWrapper<>();
                campaignQueryWrapper.eq("account_id", accountId);
                List<KuaiShouCampaign> list = campaignService.list(campaignQueryWrapper);
                if (!Check.isNull(list)) {
                    for (KuaiShouCampaign campaign : list) {
                        kuaishouInterfaceService.getAdvertiserCreativeReportDailyV2(campaign.getCampaignId(), ctopOauthToken, startDate, endDate);

                    }

                }


            }
        };
        thread.start();
    }


    @Autowired
    private IUserAllocationService userAllocationService;
    @Autowired
    private KuaishouReportDailyCreativeStatisticMapper reportDailyCreativeStatisticMapper;


    @Autowired
    private KuaishouReportDailyCreativeMapper reportDailyCreativeMapper;

    @GetMapping(value = "/getCreativeReportByProjectId")
    public void getCreativeReportByProjectId(Long projectId) {

        try {
            Map<String, Object> deleteMap = new HashMap<>();
            String date = DateUtils.getDate("yyyy-MM-dd");
            String anotherDay = DateUtils.getAnotherDay("yyyy-MM-dd", date, -1);
            SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");
            Date endDate = simpleDateFormat.parse(anotherDay);
            QueryWrapper<UserAllocation> userAllocationQueryWrapper = new QueryWrapper<>();
            userAllocationQueryWrapper.eq("project_id", projectId);
            List<UserAllocation> list = userAllocationService.list(userAllocationQueryWrapper);
            if (!Check.isNull(list)) {
                for (UserAllocation allocation : list) {
                    executorService.submit(new Runnable() {
                        @Override
                        public void run() {
                            if (!Check.isNull(allocation)) {
                                log.info("账号id:{}", allocation.getAccountId());

                                QueryWrapper<CtopOauthToken> oauthTokenQueryWrapper = new QueryWrapper<>();
                                oauthTokenQueryWrapper.eq("media_id", 2);
                                oauthTokenQueryWrapper.eq("account_id", allocation.getAccountId());
                                CtopOauthToken ctopOauthToken = oauthTokenMapper.selectOne(oauthTokenQueryWrapper);
                                if (!Check.isNull(ctopOauthToken)) {
                                    deleteMap.put("account_id", allocation.getAccountId());
                                    deleteMap.put("stat_date", anotherDay);
                                    //   reportDailyCreativeStatisticMapper.deleteByMap(deleteMap);
                                    //  reportDailyCreativeMapper.deleteByMap(deleteMap);

                                    // 1.计划数据
                                    log.info("获取计划，账号id:{}", allocation.getAccountId());
                                    kuaishouInterfaceService.getCampaignList(ctopOauthToken, null, null);
                                    // 2：广告组数据
                                    log.info("获取广告组，账号id:{}", allocation.getAccountId());
                                    kuaishouInterfaceService.getGroupList(ctopOauthToken, null, null);
                                    // 3:创意数据
                                    log.info("获取创意，账号id:{}", allocation.getAccountId());
                                    kuaishouInterfaceService.getCreativeList(ctopOauthToken, null, null);

                                    QueryWrapper<KuaiShouCampaign> campaignQueryWrapper = new QueryWrapper<>();
                                    campaignQueryWrapper.eq("account_id", ctopOauthToken.getAccountId());
                                    log.info("获取创意报表，账号id:{}", allocation.getAccountId());
                                    List<KuaiShouCampaign> campaigns = campaignService.list(campaignQueryWrapper);
                                    if (!Check.isNull(campaigns)) {
                                        for (KuaiShouCampaign campaign : campaigns) {
                                            kuaishouInterfaceService.getAdvertiserCreativeReportDailyV2(campaign.getCampaignId(), ctopOauthToken, endDate, endDate);
                                        }
                                    }
                                }
                            }

                        }
                    });


                }
            }
        } catch (ParseException e) {
            e.printStackTrace();
        }

    }

    public static void main(String[] args) throws ParseException {
        String date = DateUtils.getDate("yyyy-MM-dd");
        String anotherDay = DateUtils.getAnotherDay("yyyy-MM-dd", date, -1);
        System.err.println(anotherDay);
    }


    @GetMapping(value = "/getPlanAndGroupByAccount")
    public void getPlanAndGroupByAccount(Long accountId) {
        QueryWrapper<CtopOauthToken> oauthTokenQueryWrapper = new QueryWrapper<>();
        oauthTokenQueryWrapper.eq("media_id", 2);
        oauthTokenQueryWrapper.eq("account_id", accountId);
        oauthTokenQueryWrapper.last("limit 1");
        CtopOauthToken token = oauthTokenMapper.selectOne(oauthTokenQueryWrapper);
        try {
            System.err.println("获取计划，广告组：" + accountId);
            kuaishouInterfaceService.getCampaignList(token, null, null);
            //1：获取全量广告组数据
            kuaishouInterfaceService.getGroupList(token, null, null);
            System.err.println("获取计划，广告组：" + accountId);
        } catch (Exception e) {
            e.printStackTrace();
        }


    }


    @GetMapping(value = "/getCreativeByAccount")
    public void gerCreative(Long accountId) {
        QueryWrapper<CtopOauthToken> oauthTokenQueryWrapper = new QueryWrapper<>();
        oauthTokenQueryWrapper.eq("media_id", 2);
        oauthTokenQueryWrapper.eq("account_id", accountId);
        oauthTokenQueryWrapper.last("limit 1");
        CtopOauthToken token = oauthTokenMapper.selectOne(oauthTokenQueryWrapper);

        try {
            System.err.println("获取创意,accountId:" + token.getAccountId());
            kuaishouInterfaceService.getCreativeList(token, null, null);
            System.err.println("获取创意结束,accountId:" + token.getAccountId());
        } catch (Exception e) {
            e.printStackTrace();
        }


    }


    @GetMapping(value = "/gerCreativeReportByAccount")
    public void gerCreativeReportByAccount(Long accountId, String startDateStr, String endDateStr, QueryWrapper<CtopOauthToken> account_id) {
        Thread thread = new Thread() {
            @SneakyThrows
            @Override
            public void run() {
                SimpleDateFormat sim = new SimpleDateFormat("yyyy-MM-dd");
                Date startDate = sim.parse(startDateStr);
                Date endDate = sim.parse(endDateStr);
                //1:查询当日数据
                //executorService = Executors.newFixedThreadPool(3);
                QueryWrapper<CtopOauthToken> oauthTokenQueryWrapper = new QueryWrapper<>();
                oauthTokenQueryWrapper.eq("media_id", 2);
                oauthTokenQueryWrapper.eq("account_id", accountId);
                CtopOauthToken ctopOauthToken = oauthTokenMapper.selectOne(oauthTokenQueryWrapper);
                System.err.println("创意报表accountId:" + ctopOauthToken.getAccountId());


                QueryWrapper<KuaiShouCampaign> campaignQueryWrapper = new QueryWrapper<>();
                campaignQueryWrapper.eq("account_id", ctopOauthToken.getAccountId());

                List<KuaiShouCampaign> campaigns = campaignService.list(campaignQueryWrapper);
                if (!Check.isNull(campaigns)) {
                    for (KuaiShouCampaign campaign : campaigns) {
                        kuaishouInterfaceService.getAdvertiserCreativeReportDailyV2(campaign.getCampaignId(), ctopOauthToken, endDate, endDate);
                    }
                }

            }
        };
        thread.start();
    }


    @Autowired
    private IBytedancePlanDailyReportService planDailyReportService;
    @Autowired
    private ICtopOauthTokenService tokenService;

    @GetMapping("loadBytedanceData")
    public Map<String, Object> formatZybData(String date) {
        Map<String, Object> result = new HashMap<>();
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");
        Date getDate = null;
        try {
            getDate = simpleDateFormat.parse(date);
        } catch (ParseException e) {
            e.printStackTrace();
        }
        //1:查询当日数据
        QueryWrapper<UserAllocation> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("project_id", 215);
        List<UserAllocation> allocations = userAllocationService.list(queryWrapper);
        if (null == allocations || allocations.size() <= 0) {
            log.info("定时获取头条数据异常：获取用户信息失败");
        }
        Date finalGetDate = getDate;

        allocations.forEach(allocation -> {
            //3：获取广告计划信息数据
            CtopOauthToken token = oauthTokenMapper.selectByAccountId(allocation.getAccountId());
            reportService.getAdvertiserPlanReport(token, finalGetDate, finalGetDate, CtopAdConstant.BYTEDANCE_REPORT_TYPE_DAILY);
        });

        //清洗关于作业帮数据
        //1:查询作业帮相关的用户数据
            allocations.forEach(allocation -> {
                //根据accountId和时间，查询相关的日报表信息
                QueryWrapper<BytedancePlanDailyReport> reportQueryWrapper = new QueryWrapper<>();
                SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
                String dateString = dateFormat.format(finalGetDate) + " 00:00:00";
                queryWrapper.eq("advertiser_id", allocation.getAccountId())
                        .eq("stat_datetime", dateString)
                ;
                List<BytedancePlanDailyReport> bytedancePlanDailyReports = planDailyReportService.list(reportQueryWrapper);
                if (null != bytedancePlanDailyReports && bytedancePlanDailyReports.size() > 0) {
                    bytedancePlanDailyReports.forEach(report -> {
                        String adName = report.getAdName();
                        String[] tags = adName.split("-");
                        report.setAdsense(tags[1]);
                        report.setPlanCode(tags[2]);
                        String materialName = tags[3];
                        report.setMaterialName(materialName);
                        if (materialName.contains("其他")) {
                            report.setMaterialType("其他");
                        } else if (materialName.contains("图片轮播")) {
                            report.setMaterialType("图片轮播");
                        } else if (materialName.contains("大字报")) {
                            report.setMaterialType("大字报");
                        } else if (materialName.contains("文字动画")) {
                            report.setMaterialType("文字动画");
                        } else if (materialName.contains("采访形式")) {
                            report.setMaterialType("采访形式");
                        } else if (materialName.contains("剧情")) {
                            report.setMaterialType("剧情");
                        } else if (materialName.contains("口播")) {
                            report.setMaterialType("口播");
                        } else {
                            report.setMaterialType("其他");
                        }
                        planDailyReportService.updateById(report);
                    });
                }
            });
        ResultMapUtils.setResultMap(result, StatusCode.COMMON_SUCCESS);
        return result;
    }

    @Autowired
    private IByteDanceAdvertiserDataService advertiserDataService;
    @GetMapping("getBytedanceData")
    public Map<String, Object> getBytedanceData() {
        Map<String, Object> result = new HashMap<>();
        //1:查询当日数据
        List<CtopOauthToken> tokens = tokenService.getTokenListByType(CtopAdConstant.PLATFORM_TYPE_BYTEDANCE);
        if (null == tokens || tokens.size() <= 0) {
            log.info("定时获取头条数据异常：为获取到可用的token");
        }
        tokens.forEach(token -> {
            advertiserDataService.getMaterialList(token);
        });
        ResultMapUtils.setResultMap(result, StatusCode.COMMON_SUCCESS);
        return result;
    }

    @GetMapping("formatZybData")
    public Map<String, Object> formatZybData() {
        //清洗关于作业帮数据
        //1:查询作业帮相关的用户数据
        QueryWrapper<UserAllocation> wrapper = new QueryWrapper<>();
        wrapper.eq("project_id", 215);
        List<UserAllocation> allocations = userAllocationService.list(wrapper);
        if (null != allocations && allocations.size() > 0) {
            allocations.forEach(allocation -> {
                //根据accountId和时间，查询相关的日报表信息
                QueryWrapper<BytedancePlanDailyReport> queryWrapper = new QueryWrapper<>();
                SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
//                String dateString = dateFormat.format(getDate)+" 00:00:00";
                queryWrapper.eq("advertiser_id", allocation.getAccountId())
//                        .eq("stat_datetime",dateString)
                ;
                List<BytedancePlanDailyReport> bytedancePlanDailyReports = planDailyReportService.list(queryWrapper);
                if (null != bytedancePlanDailyReports && bytedancePlanDailyReports.size() > 0) {
                    bytedancePlanDailyReports.forEach(report -> {
                        String adName = report.getAdName();
                        String[] tags = adName.split("-");
                        report.setAdsense(tags[1]);
                        report.setPlanCode(tags[2]);
                        String materialName = tags[3];
                        report.setMaterialName(materialName);
                        if (materialName.contains("其他")) {
                            report.setMaterialType("其他");
                        } else if (materialName.contains("图片轮播")) {
                            report.setMaterialType("图片轮播");
                        } else if (materialName.contains("大字报")) {
                            report.setMaterialType("大字报");
                        } else if (materialName.contains("文字动画")) {
                            report.setMaterialType("文字动画");
                        } else if (materialName.contains("采访形式")) {
                            report.setMaterialType("采访形式");
                        } else if (materialName.contains("剧情")) {
                            report.setMaterialType("剧情");
                        } else if (materialName.contains("口播")) {
                            report.setMaterialType("口播");
                        } else {
                            report.setMaterialType("其他");
                        }
                        planDailyReportService.updateById(report);
                    });
                }
            });
        }
        Map<String, Object> result = new HashMap<>();
        ResultMapUtils.setResultMap(result, StatusCode.COMMON_SUCCESS);
        return result;
    }

    @Autowired
    private IReportService reportService;

    @GetMapping("bytedanceHourReport")
    public Map<String, Object> bytedanceHourReport() {
        Map<String, Object> result = new HashMap<>();
        log.info("头条时报数据获取开始");
        Date getDate = new Date();
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("HH");
        String hour = simpleDateFormat.format(getDate);
        if (null != hour && "00".equals(hour)) {
            getDate = DateUtils.addDay(getDate, -1);
        }
        //1:查询当日数据
        List<CtopOauthToken> tokens = tokenService.getTokenListByType(CtopAdConstant.PLATFORM_TYPE_BYTEDANCE);
        if (null == tokens || tokens.size() <= 0) {
            log.info("定时获取头条小时数据异常：未获取到可用的token");
            ResultMapUtils.setResultMap(result, StatusCode.COMMON_PARAM_ERROR);
            return result;
        }
        executorService = Executors.newFixedThreadPool(4);
        Date finalGetDate = getDate;
        tokens.forEach(token -> {
            executorService.submit(new Runnable() {
                @Override
                public void run() {
                    reportService.getAdvertiserReport(token, finalGetDate, finalGetDate, CtopAdConstant.BYTEDANCE_REPORT_TYPE_HOURLY);
                }
            });
        });
        log.info("头条时报数据获取结束");
        ResultMapUtils.setResultMap(result, StatusCode.COMMON_SUCCESS);
        return result;
    }

    //线程计数器
    static CountDownLatch countDownLatch = null;

    @GetMapping("getHourLyYddData")
    public Map<String, Object> getData() {
        log.info("头条时报数据获取开始");
        Date getDate = new Date();
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("HH");
        String hour = simpleDateFormat.format(getDate);
        if (null != hour && "00".equals(hour)) {
            getDate = DateUtils.addDay(getDate, -1);
        }
        //1:查询当日计划时报数据
        List<CtopOauthToken> tokens = tokenService.getTokenListByType(CtopAdConstant.PLATFORM_TYPE_BYTEDANCE);
        Date finalGetDate = getDate;
        executorService = Executors.newFixedThreadPool(10);
        countDownLatch = new CountDownLatch(tokens.size());
        tokens.forEach(token -> {
            //1：获取当日广告计划数据
            executorService.submit(new Runnable() {
                @Override
                public void run() {
                    try {
                        reportService.getAdvertiserPlanReport(token, finalGetDate, finalGetDate, CtopAdConstant.BYTEDANCE_REPORT_TYPE_HOURLY);
                    } catch (Exception e) {
                        e.printStackTrace();
                    } finally {
                        countDownLatch.countDown();
                    }
                }
            });
        });
        try {
            countDownLatch.await();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        log.info("头条计划时报数据获取完成");
        Map<String, Object> result = new HashMap<>();
        ResultMapUtils.setResultMap(result, StatusCode.COMMON_SUCCESS);
        return result;
    }

    @GetMapping("formatYzData")
    public Map<String, Object> formatYzData() {
        Map<String, Object> result = new HashMap<>();
        planDailyReportService.cleanYzData(151);
        ResultMapUtils.setResultMap(result, StatusCode.COMMON_SUCCESS);
        return result;
    }

    @Autowired
    private IBytedancePlanHourlyReportService planHourlyReportService;

    @GetMapping("loadCreativeData")
    public Map<String, Object> loadCreaticeData() {
        Map<String, Object> result = new HashMap<>();
        List<CtopOauthToken> tokens = tokenService.getTokenListByType(CtopAdConstant.PLATFORM_TYPE_BYTEDANCE);
        log.info("头条创意素材数据开始获取");
        //查询当日数据
        if (null == tokens || tokens.size() <= 0) {
            log.info("定时获取头条数据异常：wei获取到可用的token");
            ResultMapUtils.setResultMap(result, StatusCode.COMMON_SERVER_ERROR);
            return result;
        }
        executorService = Executors.newFixedThreadPool(20);
        countDownLatch = new CountDownLatch(tokens.size());
        tokens.forEach(token -> {
            executorService.submit(new Runnable() {
                @Override
                public void run() {
                    // 获取广告创意信息数据
                    try {
                        advertiserDataService.getAdvertiserCreative(token, null);
                    } catch (Exception e) {
                        e.printStackTrace();
                    } finally {
                        countDownLatch.countDown();
                    }
                }
            });
        });
        try {
            countDownLatch.await();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        log.info("头条创意素材数据获取完成");
        ResultMapUtils.setResultMap(result, StatusCode.COMMON_SUCCESS);
        return result;
    }

    @GetMapping("loadCreaticeReportData")
    public Map<String, Object> loadCreaticeReportData() {
        Map<String, Object> result = new HashMap<>();
        List<CtopOauthToken> tokens = tokenService.getTokenListByType(CtopAdConstant.PLATFORM_TYPE_BYTEDANCE);
        for (int i = 51; i < 180; i++) {
            Date getDate = DateUtils.addDay(new Date(), -i);
            log.info(DateUtils.formatDate(getDate) + "头条创意日报数据开始获取");
            //查询当日数据
            if (null == tokens || tokens.size() <= 0) {
                log.info("定时获取头条数据异常：为获取到可用的token");
                continue;
            }
            executorService = Executors.newFixedThreadPool(10);
            countDownLatch = new CountDownLatch(tokens.size());
            tokens.forEach(token -> {
                executorService.submit(new Runnable() {
                    @Override
                    public void run() {
                        //获取广告创意日报信息数据
                        try {
                            reportService.getAdvertiserCreativeReport(token, getDate, getDate, CtopAdConstant.BYTEDANCE_REPORT_TYPE_DAILY);
                        } catch (Exception e) {
                            e.printStackTrace();
                        } finally {
                            countDownLatch.countDown();
                        }
                    }
                });
            });
            try {
                countDownLatch.await();
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            log.info(DateUtils.formatDate(getDate) + "头条创意日报数据获取完成");
        }
        ResultMapUtils.setResultMap(result, StatusCode.COMMON_SUCCESS);
        return result;
    }

    @GetMapping("loadVideoData")
    public Map<String, Object> loadVideoData() {
        log.info("素材数据获取开始");
        //1:查询当日计划时报数据
        List<CtopOauthToken> tokens = tokenService.getTokenListByType(CtopAdConstant.PLATFORM_TYPE_BYTEDANCE);
        executorService = Executors.newFixedThreadPool(10);
        countDownLatch = new CountDownLatch(tokens.size());
        tokens.forEach(token -> {
            //1：获取当日广告计划数据
            executorService.submit(new Runnable() {
                @Override
                public void run() {
                    try {
                        advertiserDataService.getMaterialList(token);
                    } catch (Exception e) {
                        e.printStackTrace();
                    } finally {
                        countDownLatch.countDown();
                    }
                }
            });
        });
        try {
            countDownLatch.await();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        log.info("头条素材数据获取完成");
        Map<String, Object> result = new HashMap<>();
        ResultMapUtils.setResultMap(result, StatusCode.COMMON_SUCCESS);
        return result;
    }


    @Autowired
    private ICleanMaterialService cleanMaterialService;

    @GetMapping("testReport")
    public void testReport() {
        List<String> signatureList = cleanMaterialService.getSignature();
        if (Check.isNull(signatureList)) {
            log.error("素材数据获取为空");
            return;
        }
        executorService = Executors.newFixedThreadPool(5);
        for (int i = 0; i < signatureList.size(); i++) {
            String signature = signatureList.get(i);
            executorService.submit(new Runnable() {
                @Override
                public void run() {
                    System.err.println(signature);
                    cleanMaterialService.calculationReport(signature);
                }
            });
        }


    }

    @GetMapping(value = "/AccountReportByAccount")
    public void AccountReportByAccount(Long accountId, String startDateStr, String endDateStr) {
        QueryWrapper<CtopOauthToken> oauthTokenQueryWrapper = new QueryWrapper<>();
        oauthTokenQueryWrapper.eq("media_id", 2);
        oauthTokenQueryWrapper.eq("account_id", accountId);
        oauthTokenQueryWrapper.last("limit 1");
        CtopOauthToken token = oauthTokenMapper.selectOne(oauthTokenQueryWrapper);
        executorService.submit(new Runnable() {
            @Override
            public void run() {
                try {
                    SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");
                    Date startDate = null;
                    Date endDate = null;
                    try {
                        startDate = simpleDateFormat.parse(startDateStr);
                        endDate = simpleDateFormat.parse(endDateStr);
                    } catch (ParseException e) {
                        e.printStackTrace();
                    }
                    System.err.println("获取广告主报表,accountId:" + token.getAccountId());
                    kuaishouInterfaceService.getAdvertiserReportDaily(token, startDate, endDate);

                    Thread.sleep(1 * 200);
                    //  kuaishouInterfaceService.getAppList(token.getAccountId(), token.getAccessToken());
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });
    }
}
