package org.jeecg.modules.ctop.job;


import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.util.DateUtils;
import org.jeecg.modules.system.service.IPerformanceService2;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.springframework.beans.factory.annotation.Autowired;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

@Slf4j
public class EffiVideoJob implements Job {
    @Autowired
    private IPerformanceService2 performanceService;

    /**
     * 获取有效视频以及对应人的定时任务
     *
     * @param jobExecutionContext
     * @throws JobExecutionException
     */
    @Override
    public void execute(JobExecutionContext jobExecutionContext) {
        //有效视频定时任务，默认跑前一天的
        DateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        String calcDate = sdf.format(DateUtils.addDay(new Date(), -1));
        log.info("有效视频定时任务开始执行,有效视频所属时间为" + calcDate);
        performanceService.efficientVideoTask(sdf.format(DateUtils.addDay(new Date(), -1)));
        log.info("有效视频定时任务结束");
    }
}
