package org.jeecg.modules.ctop.job;

import cn.com.ctop.common.module.entity.CtopOauthToken;
import cn.com.ctop.common.module.mapper.CtopOauthTokenMapper;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaishouInterfaceService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import lombok.extern.slf4j.Slf4j;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

/**
 * 获取广告计划分时报表
 */
@Slf4j
public class KuaishouAppListJob implements Job {
    @Autowired
    private IKuaishouInterfaceService kuaishouInterfaceService;
    @Autowired
    private CtopOauthTokenMapper oauthTokenMapper;

    static ExecutorService executorService = Executors.newFixedThreadPool(3);

    @Override
    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {

        Thread thread = new Thread() {
            @Override
            public void run() {
                QueryWrapper<CtopOauthToken> oauthTokenQueryWrapper = new QueryWrapper<>();
                oauthTokenQueryWrapper.eq("media_id", 2);
                List<CtopOauthToken> tokens = oauthTokenMapper.selectList(oauthTokenQueryWrapper);
                for (CtopOauthToken token : tokens) {
                    executorService.submit(new Runnable() {
                        @Override
                        public void run() {
                            try {
                                kuaishouInterfaceService.getAppList(token.getAccountId(), token.getAccessToken());
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                        }
                    });
                }

            }

        };
        thread.start();


    }
}
