package org.jeecg.modules.ctop.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.jeecg.modules.ctop.entity.DramaItemInfo;
import org.jeecg.modules.ctop.entity.DramaRoleInfo;
import org.jeecg.modules.ctop.mapper.DramaItemInfoMapper;
import org.jeecg.modules.ctop.service.IDramaItemInfoService;
import org.jeecg.modules.ctop.service.IDramaRoleInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * 剧本内容信息
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2020-03-06
 */
@Service
public class DramaItemInfoServiceImpl extends ServiceImpl<DramaItemInfoMapper, DramaItemInfo> implements IDramaItemInfoService {

    @Autowired
    private IDramaRoleInfoService roleInfoService;

    @Override
    public List<DramaItemInfo> getByDramaId(Long dramaId) {
        QueryWrapper<DramaItemInfo> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("drama_id", dramaId).eq("enabled", 1).orderByAsc("rank");
        List<DramaItemInfo> infos = this.list(queryWrapper);
        List<DramaItemInfo> returnInfos = new ArrayList<>();
        if (null != infos && infos.size() > 0) {
            for (DramaItemInfo itemInfo : infos) {
                if (null != itemInfo.getRoleId()) {
                    DramaRoleInfo roleInfo = roleInfoService.getById(itemInfo.getRoleId());
                    itemInfo.setRoleName(roleInfo.getName());
                }
                returnInfos.add(itemInfo);
            }
        }
        return returnInfos;
    }
}
