package org.jeecg.modules.system.service;

import cn.com.ctop.common.module.entity.MaterialInfo;
import cn.com.ctop.performanceappraisal.entity.Performance;
import cn.com.ctop.userefficientvideomap.entity.AccountDTO;
import cn.com.ctop.userefficientvideomap.entity.DesignMaterialInfo;
import cn.com.ctop.userefficientvideomap.entity.UserDto2;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;
import java.util.Map;

/**
 * 设计师季度绩效表
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2019-12-10
 */
public interface IPerformanceService2 extends IService<Performance> {
    /**
     * 查询统计有效视频
     *
     * @param calcDateStr
     */
    void efficientVideoTask(String calcDateStr);

    /**
     * 平台的总有效数量、素材总数、素材有效率、总跑量、当前可获得绩效
     *
     * @return
     */
    Map<String, Object> getPerformanceInfo();

    /**
     * 有效率排行榜
     *
     * @param size
     * @return
     */
    Map<String, Object> effiRateRank(Integer size);

    /**
     * 素材、素材跑量、封面点击数、封面曝光数、行为数
     *
     * @return
     */
    List<DesignMaterialInfo> materialInfoList();

    /**
     * 点击+符号 投放账户、投放账户、跑量
     *
     * @param materialInfoId
     * @return
     */
    List<DesignMaterialInfo> materialAccountInfo(String materialInfoId);

    void designerPerformanceTask(int year, int quarter);

    void kuaishouDesigner(int thisYear, int thisQuarter);

    void toutiaoDesigner(int thisYear, int thisQuarter);

    Map<String, Object> designerLastQuarterPerformanceInfo();

    Map<String, Object> quarterUserPerformanceList(Integer appType);

    Map<String, Object> kuaishouDesignerLastQuarterPerformanceInfo();

    Map<String, Object> planeLastQuarterPerformanceInfo(int appType);

    //获取快手绩效时时数据接口
    List<UserDto2> kuaishouPerformanceInfoNow();

    //获取快手绩效时时数据接口
    List<UserDto2> toutiaoPerformanceInfoNow();

    //获取快手绩效周报表
    List<UserDto2> kuaishouWeekReport(String startDate, String endDate);

    //获取头条绩效周报表
    List<UserDto2> toutiaoWeekReport(String startDate, String endDate);

    //获取快手季度绩效报表
    List<UserDto2> kuaishouQuarterReport(Integer year, Integer quarter);

    //获取头条季度绩效报表
    List<UserDto2> toutiaoQuarterReport(Integer year, Integer quarter);

    //获取有效视频列表
    List<MaterialInfo> effiVideoList(Integer appType, Integer year, Integer quarter, String userId);

    List<MaterialInfo> getEffiWeekVideoList(Integer appType, String startDate, String endDate, String userId);

    //获取快手优化师绩效实时数据
    List<UserDto2> kuaishouYouhuaPerformanceInfoNow();

    //获取头条优化师实时数据
    List<UserDto2> toutiaoYouhuaPerformanceInfoNow();

    //获取快手优化师所属账号信息
    List<AccountDTO> getKuaiShouYouhuaAccountsList(String userId, Integer appType, Integer year , Integer quarter);

    //获取头条优化师所属账号信息
    List<AccountDTO> getToutiaoYouhuaAccountsList(String userId, Integer appType, Integer year , Integer quarter);

    //快手优化师周报
    List<UserDto2> kuaishouYouhuaWeekReport(String startDate, String endDate);

    //头条优化师周报
    List<UserDto2> toutiaoYouhuaWeekReport(String startDate, String endDate);

    //快手优化季度绩效报表
    List<UserDto2> kuaishouYouhuaQuarterReport(Integer year, Integer quarter);

    //头条优化季度绩效报表
    List<UserDto2> toutiaoYouhuaQuarterReport(Integer year, Integer quarter);
}
