package org.jeecg;

import cn.com.ctop.common.module.entity.CtopOauthToken;
import cn.com.ctop.common.module.service.ICtopOauthTokenService;
import cn.com.ctop.common.module.utils.CtopAdConstant;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaiShouHistoryReportTaskService;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.util.DateUtils;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.Date;
import java.util.List;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

@RunWith(SpringRunner.class)
@SpringBootTest
@Slf4j
public class SampleTest {


    @Autowired
    private IKuaiShouHistoryReportTaskService reportTaskService;

    @Test
    public void kuaisShouReport() {
        try {
//            reportTaskService.createTask(3727345L, "871fc2c248782a94ad2962c941555abc", "");
//            reportTaskService.getTaskList();

/*
            reportTaskService.createTask(3727345L, "871fc2c248782a94ad2962c941555abc");
            reportTaskService.getTaskList();*/



         /*   String url = "https://ad.e.kuaishou.com/rest/openapi/v1/async_task/list";
            Map<String, String> headers = new HashMap<>();
            headers.put("Content-Type", " application/json");
            headers.put("Access-Token", "eb9a0d18072eabc339ee26ad010ecd6b");
            JSONObject param = new JSONObject();
            param.put("advertiser_id", 142402);
            JSONArray taskIds = new JSONArray();
            taskIds.add(1229917);

            param.put("task_ids", taskIds);
            String result = HttpUtils.kuaiShouhttpPostRequest(url, param.toJSONString(), headers);
            JSONObject resultJson = JSONObject.parseObject(result);
            System.err.println(resultJson);*/


          /*  String url = "https://ad.e.kuaishou.com/rest/openapi/v1/async_task/download";

            Map<String, String> headers = new HashMap<>();
            headers.put("Access-Token", "eb9a0d18072eabc339ee26ad010ecd6b");

            Map<String,Object> param = new HashMap<>();
            param.put("advertiser_id", 142402);
            param.put("task_id", "1229917");
            String result = HttpUtils.KuaiShouttpGetRequest(url, param,headers);*/


            /*URL url = new URL("https://ad.e.kuaishou.com/rest/openapi/v1/async_task/download?task_id=1229917&advertiser_id=142402");
            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
            //设置超时间为3秒
            conn.setConnectTimeout(10 * 1000);
            //防止屏蔽程序抓取而返回403错误
            conn.setRequestProperty("User-Agent", "Mozilla/4.0 (compatible; MSIE 5.0; Windows NT; DigExt)");
            conn.setRequestProperty("Access-Token", "6a1fbe20e49fe519ec8120aac5c9e55a");
            //得到输入流
            InputStream inputStream = conn.getInputStream();
            //获取自己数组
            byte[] getData = readInputStream(inputStream);

            //文件保存位置
            File saveDir = new File("D:\\file");
            if (!saveDir.exists()) {
                saveDir.mkdirs();
            }
            String fileName = "123.csv";
            File file = new File(saveDir + File.separator + fileName);
            FileOutputStream fos = new FileOutputStream(file);
            fos.write(getData);
            if (fos != null) {
                fos.close();
            }
            if (inputStream != null) {
                inputStream.close();
            }*/
         /*   String localPath = "D:\\file\\123.csv";

            reportDailyAccountMapper.loadAccountDailyReport(142402L,localPath);*/


        } catch (Exception e) {
            e.printStackTrace();

        }
    }

    @Autowired
    private ICtopOauthTokenService tokenService;
    private static ExecutorService executorService = Executors.newFixedThreadPool(3);
    private static CountDownLatch countDownLatch = null;

    @Test
    public void testLoadJob() {
        log.info("快手获取日报数据任务执行开始");
        Long start = System.currentTimeMillis();
        Date getDate = DateUtils.addDay(new Date(), -1);
        List<CtopOauthToken> tokens = tokenService.getTokenListByType(CtopAdConstant.PLATFORM_TYPE_KUAISHOU);
        if (null == tokens || tokens.size() <= 0) {
            log.info("快手获取日报数据任务执行失败:未获取到可用的token");
            return;
        }
        String getDateStr = DateUtils.formatDate(getDate);
        countDownLatch = new CountDownLatch(tokens.size());
        for (CtopOauthToken token : tokens) {
            executorService.submit(new Runnable() {
                @Override
                public void run() {
                    //创建任务
                    try {
                        reportTaskService.createTask(token.getAccountId(), token.getAccessToken(), getDateStr, getDateStr, CtopAdConstant.KUAISHOU_LOAD_JOB_TYPE_DAILY);
                    } catch (Exception e) {
                        e.printStackTrace();
                    } finally {
                        countDownLatch.countDown();
                    }
                }
            });
        }
        try {
            countDownLatch.await();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        Long end = System.currentTimeMillis();
        log.info("快手获取日报数据任务执行结束,执行耗时：{}秒", (end - start) / 1000);
    }


}



