package cn.com.ctop.common.module.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 账号绑定-登陆
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2019-07-31
 */
@Data
@TableName("ctop_bind_account_login")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_bind_account_login对象", description = "账号绑定-登陆")
public class BindAccountLogin {

    /**
     * 主键ID
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "主键ID")
    private Long id;
    /**
     * 广告id
     */
    @Excel(name = "广告id", width = 15)
    @ApiModelProperty(value = "广告id")
    private String advertiserId;

    /**
     * 广告名称
     */
    @Excel(name = "广告名称", width = 15)
    @ApiModelProperty(value = "广告名称")
    private String advertiserName;
    /**
     * 广告id
     */
    @Excel(name = "平台账户id", width = 15)
    @ApiModelProperty(value = "平台账户id")
    private String accountId;
    /**
     * 广告id
     */
    @Excel(name = "用户Id", width = 15)
    @ApiModelProperty(value = "用户id")
    private String userId;
    /**
     * 账号
     */
    @Excel(name = "账号", width = 15)
    @ApiModelProperty(value = "账号")
    private String accountName;
    /**
     * 密码
     */
    @Excel(name = "密码", width = 15)
    @ApiModelProperty(value = "密码")
    private String password;
    /**
     * 登录方式
     */
    @Excel(name = "登录方式", width = 15)
    @ApiModelProperty(value = "登录方式")
    private String loginType;
    /**
     * 1未登陆 2已登陆
     */
    @Excel(name = "1未登陆 2已登陆", width = 15)
    @ApiModelProperty(value = "1未登陆 2已登陆")
    private String status;
    /**
     * 创建时间
     */
    @Excel(name = "创建时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 修改时间
     */
    @Excel(name = "修改时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;
}
