package cn.com.ctop.common.module.service;

import cn.com.ctop.common.module.entity.MaterialInfo;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.service.IService;
import org.apache.ibatis.annotations.Param;

import java.util.Map;

/**
 * 素材信息
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2019-10-11
 */
public interface IMaterialInfoService extends IService<MaterialInfo> {
    MaterialInfo getMaterialInfoByCodeAndProjectId(String code, Long projectId);

    MaterialInfo getMaterialInfoByCode(String code);

    Map<String, Object> checkMaterialInfo(String code, Long projectId);

    Map<String, Object> insert(JSONObject jsonObject);

    JSONObject getDetail(String materialId);

    JSONObject report(String userId);

    String getRoleCodeByUserId(String userId);

    void watermarkVideo(String materialId, Integer videoWatermarkTemplateId, String userId);

    void getFile(MaterialInfo materialInfo);

    void setExcellent(String id, Integer excellent);

    Integer getKuaishouUpVideoCount(@Param("code")String code);

    Integer getToutiaoUpVideoCount(@Param("code")String code);

    JSONObject getGeneralizationInfo(String code);
}
