package cn.com.ctop.crawler.modules.appium.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;

import java.util.Date;

/**
 * 手机设备表
 * @author jeecg-boot
 * @date 2019-10-31
 * @version V1.0
 */
@Data
@TableName("ctop_appium_device")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_appium_device对象", description = "手机设备表")
public class AppiumDevice {

    /**
     * 主键
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "主键")
    private Integer id;
    /**
     * IP
     */
    @Excel(name = "IP", width = 15)
    @ApiModelProperty(value = "IP")
    private String ip;
    /**
     * 端口号
     */
    @Excel(name = "端口号", width = 15)
    @ApiModelProperty(value = "端口号")
    private String port;
    /**
     * 状态
     */
    @Excel(name = "状态", width = 15)
    @ApiModelProperty(value = "状态")
    private Integer status;
    /**
     * createTime
     */
    @ApiModelProperty(value = "createTime")
    private Date createTime;
    /**
     * updateTime
     */
    @ApiModelProperty(value = "updateTime")
    private Date updateTime;
}
