package cn.com.ctop.crawler.modules.appium.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;

import java.util.Date;

/**
 * 爬虫调度任务绑定信息
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2019-11-14
 */
@Data
@TableName("ctop_appium_job_bind_task_info")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_appium_job_bind_task_info对象", description = "爬虫调度任务绑定信息")
public class AppiumJobBindTaskInfo {

    /**
     * id
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "id")
    private Long id;
    /**
     * 任务号
     */
    @Excel(name = "任务号", width = 15)
    @ApiModelProperty(value = "任务号")
    private Long jobId;
    /**
     * 执行任务id
     */
    @Excel(name = "执行任务id", width = 15)
    @ApiModelProperty(value = "执行任务id")
    private Long taskId;
    /**
     * 任务绑定状态
     */
    @Excel(name = "任务绑定状态", width = 15)
    @ApiModelProperty(value = "任务绑定状态")
    private Integer status;
    /**
     * createTime
     */
    @ApiModelProperty(value = "createTime")
    private Date createTime;
    /**
     * updateTime
     */
    @ApiModelProperty(value = "updateTime")
    private Date updateTime;
}
