package cn.com.ctop.crawler.modules.appium.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;

import java.util.Date;
import java.util.List;

/**
 * 任务表
 * @author jeecg-boot
 * @date 2019-10-31
 * @version V1.0
 */
@Data
@TableName("ctop_appium_task")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_appium_task对象", description = "任务表")
public class AppiumTask {

    /**
     * 主键
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "主键")
    private Integer id;
    /**
     * 任务名称
     */
    @Excel(name = "任务名称", width = 15)
    @ApiModelProperty(value = "任务名称")
    private String taskName;
    /**
     * APP包名
     */
    @Excel(name = "APP包名", width = 15)
    @ApiModelProperty(value = "APP包名")
    private String appPackage;
    /**
     * APP界面名
     */
    @Excel(name = "APP界面名", width = 15)
    @ApiModelProperty(value = "APP界面名")
    private String appActivity;
    /**
     * createTime
     */
    @ApiModelProperty(value = "createTime")
    private Date createTime;
    /**
     * updateTime
     */
    @ApiModelProperty(value = "updateTime")
    private Date updateTime;
    @TableField(exist = false)
    private List<AppiumTask> subList;
}
