package cn.com.ctop.crawler.modules.appium.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;

import java.util.Date;
import java.util.List;

/**
 * 任务内容表
 * @author jeecg-boot
 * @date 2019-10-31
 * @version V1.0
 */
@Data
@TableName("ctop_appium_task_item")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_appium_task_item对象", description = "任务内容表")
public class AppiumTaskItem {

	/**
	 * 主键
	 */
	@TableId(type = IdType.AUTO)
	@ApiModelProperty(value = "主键")
	private Integer id;
	/**
	 * 任务ID
	 */
	@Excel(name = "任务ID", width = 15)
	@ApiModelProperty(value = "任务ID")
	private Long taskId;
	/**
	 * 父ID
	 */
	@Excel(name = "父ID", width = 15)
	@ApiModelProperty(value = "父ID")
	private Integer parentId;
	/**
	 * 顺序
	 */
	@Excel(name = "顺序", width = 15)
	@ApiModelProperty(value = "顺序")
	private Integer seq;
	/**
	 * 查找类型
	 */
	@Excel(name = "查找类型", width = 15)
	@ApiModelProperty(value = "查找类型")
	private String findType;

    @Excel(name = "名称", width = 15)
    @ApiModelProperty(value = "名称")
    private String name;
	/**
	 * 查找关键字
	 */
	@Excel(name = "查找关键字", width = 15)
	@ApiModelProperty(value = "查找关键字")
	private String findKey;
	/**
	 * 点击类型
	 */
	@Excel(name = "点击类型", width = 15)
	@ApiModelProperty(value = "点击类型")
	private String clickType;
	/**
	 * 偏移量X
	 */
	@Excel(name = "偏移量X", width = 15)
	@ApiModelProperty(value = "偏移量X")
	private Integer offsiteX;
	/**
	 * 偏移量Y
	 */
	@Excel(name = "偏移量Y", width = 15)
	@ApiModelProperty(value = "偏移量Y")
	private Integer offsiteY;
	/**
	 * 循环间隔
	 */
	@Excel(name = "循环间隔", width = 15)
	@ApiModelProperty(value = "循环间隔")
	private Integer loopRate;
	/**
	 * 循环类型
	 */
	@Excel(name = "循环类型", width = 15)
	@ApiModelProperty(value = "循环类型")
	private String loopType;
	/**
	 * 是否必经执行
	 */
	@Excel(name = "是否必经执行", width = 15)
	@ApiModelProperty(value = "是否必经执行")
	private Integer isMust;
	/**
	 * 文本查找类型
	 */
	@Excel(name = "文本查找类型", width = 15)
	@ApiModelProperty(value = "文本查找类型")
	private String textEqualType;
	/**
	 * 文本查找关键字
	 */
	@Excel(name = "文本查找关键字", width = 15)
	@ApiModelProperty(value = "文本查找关键字")
	private String textEqualKey;
	/**
	 * 滑动类型
	 */
	@Excel(name = "滑动类型", width = 15)
	@ApiModelProperty(value = "滑动类型")
	private String swapType;
	/**
	 * 延迟时长
	 */
	@Excel(name = "延迟时长", width = 15)
	@ApiModelProperty(value = "延迟时长")
	private Integer waitTime;
	/**
	 * 是否执行完关闭
	 */
	@Excel(name = "是否执行完关闭", width = 15)
	@ApiModelProperty(value = "是否执行完关闭")
	private Integer isClose;
	/**
	 * createTime
	 */
    @ApiModelProperty(value = "createTime")
	private Date createTime;
	/**updateTime*/
    @ApiModelProperty(value = "updateTime")
	private Date updateTime;

    @ApiModelProperty(value = "appPackage")
    private String appPackage;
    @ApiModelProperty(value = "appActivity")
    private String appActivity;

    @TableField(exist = false)
    private List<AppiumTaskItem> subList;
}
