package cn.com.ctop.crawler.modules.appium.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecg.common.aspect.annotation.Dict;
import org.jeecgframework.poi.excel.annotation.Excel;

import java.util.Date;

/**
 * 任务日志表
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2019-11-01
 */
@Data
@TableName("ctop_appium_task_log")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_appium_task_log对象", description = "任务日志表")
public class AppiumTaskLog {

    /**
     * 主键
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "主键")
    private Long id;
    /**
     * 任务ID
     */
    @Excel(name = "任务ID", width = 15)
    @ApiModelProperty(value = "任务ID")
    private Long taskId;
    /**
     * 设备ID
     */
    @Excel(name = "设备ID", width = 15)
    @ApiModelProperty(value = "设备ID")
    private Integer deviceId;
    /**
     * 任务名称
     */
    @Excel(name = "任务名称", width = 15)
    @ApiModelProperty(value = "任务名称")
    private String taskName;
    /**
     * 设备IP
     */
    @Excel(name = "设备IP", width = 15)
    @ApiModelProperty(value = "设备IP")
    private String deviceIp;
    /**
     * 设备端口
     */
    @Excel(name = "设备端口", width = 15)
    @ApiModelProperty(value = "设备端口")
    private String devicePort;
    /**
     * 状态
     */
    @Excel(name = "状态", width = 15)
    @Dict(dicCode = "appium_ks_log_status")
    @ApiModelProperty(value = "状态")
    private String status;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 修改时间
     */
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;
}
