package cn.com.ctop.crawler.modules.dataeye.service.impl;

import cn.com.ctop.common.module.utils.HttpUtils;
import cn.com.ctop.crawler.modules.core.util.SignUtil;
import cn.com.ctop.crawler.modules.dataeye.entity.DataeyeCompany;
import cn.com.ctop.crawler.modules.dataeye.mapper.DataeyeCompanyMapper;
import cn.com.ctop.crawler.modules.dataeye.service.DataeyeCompanyService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.google.gson.Gson;
import org.apache.http.cookie.Cookie;
import org.apache.http.impl.cookie.BasicClientCookie;
import org.jeecg.common.util.DateUtils;
import org.springframework.stereotype.Service;
import sun.misc.BASE64Encoder;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
@Service
public class DataeyeCompanyServiceImpl extends ServiceImpl<DataeyeCompanyMapper, DataeyeCompany> implements DataeyeCompanyService {

    public void getCompanyInfo(Integer companyId){
        Map<String,String> headerMap = new HashMap<>();
        headerMap.put("Host","adx.dataeye.com");
        headerMap.put("Origin","https://adx.dataeye.com");
        headerMap.put("Referer","https://adx.dataeye.com/");
        BasicClientCookie ck = new BasicClientCookie("tokenglobal", "721501ec4ec04a50bbffc0c0240cbbdd63a0d5456205b9a5ea1581ce6c6554ca");
        ck.setDomain("adx.dataeye.com");
        ck.setExpiryDate(DateUtils.addDay(new Date(),365));
        ck.setPath("/");
        HttpUtils.COOKIESTORE.addCookie(ck);
        Map<String,Object> paramMap = new HashMap<>();
        paramMap.put("companyId",companyId);
        paramMap.put("thisTimes",(long)(new Date().getTime()/100));
        String sign = SignUtil.getDataeyeSign(paramMap);
        paramMap.put("sign",sign);
        System.out.println(new Gson().toJson(paramMap));
        String response = HttpUtils.httpPostFormRequest("https://adx.dataeye.com/company/getCompanyInfo",paramMap,headerMap);
        ObjectMapper mapper = new ObjectMapper();
        mapper.disable(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES);
        try {
            JsonNode rootNode = mapper.readTree(response);
            int statusCode = rootNode.get("statusCode").asInt();
            if (statusCode == 200){
                String content = rootNode.get("content").toString();
                DataeyeCompany company = mapper.readValue(content,DataeyeCompany.class);
                this.save(company);
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        System.out.println(response);
    }


    public static void main(String[] args){
        DataeyeCompanyServiceImpl i = new DataeyeCompanyServiceImpl();
        i.getCompanyInfo(1);
//        Date date = new Date(1582598505897L);
//        System.out.println(DateUtils.formatDate(1582598505897L));


    }
}
