package cn.com.ctop.kuaishou.modules.batch.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * @Description: 快手-创意信息
 * @Author: jeecg-boot
 * @Date: 2019-07-23
 * @Version: V1.0
 */
@Data
@TableName("ctop_kuaishou_creative")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_kuaishou_creative对象", description = "快手-创意信息")
public class KuaiShouCreative {

    /**
     * id
     */
    @TableId
    @ApiModelProperty(value = "id")
    private String id;

    /**
     * 账户ID
     */
    @Excel(name = "账户ID", width = 15)
    @ApiModelProperty(value = "账户ID")
    private Long accountId;
    /**
     * 广告计划ID
     */
    @Excel(name = "广告计划ID", width = 15)
    @ApiModelProperty(value = "广告计划ID")
    private Long campaignId;
    /**
     * 广告组ID
     */
    @Excel(name = "广告组ID", width = 15)
    @ApiModelProperty(value = "广告组ID")
    private Long unitId;
    /**
     * 广告创意ID
     */
    @Excel(name = "广告创意ID", width = 15)
    @ApiModelProperty(value = "广告创意ID")
    private Long creativeId;


    /**
     * 素材类型
     */
    private Integer creativeMaterialType;

    /**
     * 广告创意名称
     */
    @Excel(name = "广告创意名称", width = 15)
    @ApiModelProperty(value = "广告创意名称")
    private String creativeName;
    /**
     * 单图创意ur
     */
    @Excel(name = "单图创意ur", width = 15)
    @ApiModelProperty(value = "单图创意ur")
    private String materialUrl;
    /**
     * 单图创意image_token
     */
    @Excel(name = "单图创意image_token", width = 15)
    @ApiModelProperty(value = "单图创意image_token")
    private String imageTokens;
    /**
     * 视频作品ID
     */
    @Excel(name = "视频作品ID", width = 15)
    @ApiModelProperty(value = "视频作品ID")
    private String photoId;
    /**
     * 广告创意状态
     */
    @Excel(name = "广告创意状态", width = 15)
    @ApiModelProperty(value = "广告创意状态")
    private Integer status;
    /**
     * 投放状态 1：投放中；2：暂停
     */
    @Excel(name = "投放状态 1：投放中；2：暂停", width = 15)
    @ApiModelProperty(value = "投放状态 1：投放中；2：暂停")
    private Integer putStatus;
    /**
     * 创建渠道  0：投放后台创建；1：Marketing API创建
     */
    @Excel(name = "创建渠道  0：投放后台创建；1：Marketing API创建", width = 15)
    @ApiModelProperty(value = "创建渠道  0：投放后台创建；1：Marketing API创建")
    private Integer createChannel;
    /**
     * 审核拒绝理由
     */
    @Excel(name = "审核拒绝理由", width = 15)
    @ApiModelProperty(value = "审核拒绝理由")
    private String reviewDetail;
    /**
     * 封面URL
     */
    @Excel(name = "封面URL", width = 15)
    @ApiModelProperty(value = "封面URL")
    private String coverUrl;
    /**
     * 视频封面token  若创意使用系统自动生成的首帧图片作为封面，该token无法复用
     */
    @Excel(name = "视频封面token  若创意使用系统自动生成的首帧图片作为封面，该token无法复用", width = 15)
    @ApiModelProperty(value = "视频封面token  若创意使用系统自动生成的首帧图片作为封面，该token无法复用")
    private String imageToken;
    /**
     * 封面图宽度
     */
    @Excel(name = "封面图宽度", width = 15)
    @ApiModelProperty(value = "封面图宽度")
    private String coverWidth;
    /**
     * 封面图高度
     */
    @Excel(name = "封面图高度", width = 15)
    @ApiModelProperty(value = "封面图高度")
    private String coverHeight;
    /**
     * 动态词包原始封面图片URL
     */
    @Excel(name = "动态词包原始封面图片URL", width = 15)
    @ApiModelProperty(value = "动态词包原始封面图片URL")
    private String overlayBgUrl;
    /**
     * 动态词包原始封面图片token
     */
    @Excel(name = "动态词包原始封面图片token", width = 15)
    @ApiModelProperty(value = "动态词包原始封面图片token")
    private String overlayBgImageToken;
    /**
     * stickerTitle
     */
    @Excel(name = "stickerTitle", width = 15)
    @ApiModelProperty(value = "stickerTitle")
    private String stickerTitle;
    /**
     * 贴纸样式类型
     */
    @Excel(name = "贴纸样式类型", width = 15)
    @ApiModelProperty(value = "贴纸样式类型")
    private String overlayType;
    /**
     * 广告语
     */
    @Excel(name = "广告语", width = 15)
    @ApiModelProperty(value = "广告语")
    private String description;
    /**
     * 行动号召按钮文案
     */
    @Excel(name = "行动号召按钮文案", width = 15)
    @ApiModelProperty(value = "行动号召按钮文案")
    private String actionBarText;
    /**
     * 点击测试链接
     */
    @Excel(name = "点击测试链接", width = 15)
    @ApiModelProperty(value = "点击测试链接")
    private String clickTrackUrl;
    /**
     * 第三方开始播放监测链接
     */
    @Excel(name = "第三方开始播放监测链接", width = 15)
    @ApiModelProperty(value = "第三方开始播放监测链接")
    private String impressionUrl;
    /**
     * 第三方有效播放监测链接
     */
    @Excel(name = "第三方有效播放监测链接", width = 15)
    @ApiModelProperty(value = "第三方有效播放监测链接")
    private String adPhotoPlayedT3sUrl;
    /**
     * 创建时间
     */
    @Excel(name = "创建时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 修改时间
     */
    @Excel(name = "修改时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;

    private Integer firstFrameType;

    private Date creativeCreateTime;

    private Date creativeUpdateTime;
}
