package cn.com.ctop.kuaishou.modules.report.service.impl;

import cn.com.ctop.kuaishou.modules.report.entity.KuaishouReportDailyAgent;
import cn.com.ctop.kuaishou.modules.report.entity.KuaishouReportDailyAgentSum;
import cn.com.ctop.kuaishou.modules.report.mapper.KuaishouReportDailyAgentSumMapper;
import cn.com.ctop.kuaishou.modules.report.service.IKuaishouReportDailyAgentSumService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import java.util.List;

/**
 * 代理商日汇总表
 * @author jeecg-boot
 * @date   2019-12-13
 * @version V1.0
 */
@Service
public class KuaishouReportDailyAgentSumServiceImpl extends ServiceImpl<KuaishouReportDailyAgentSumMapper, KuaishouReportDailyAgentSum> implements IKuaishouReportDailyAgentSumService {

    @Autowired
    private KuaishouReportDailyAgentSumMapper kuaishouReportDailyAgentSumMapper;

    //公司报表
    public List<KuaishouReportDailyAgentSum> companyReport(String startDate, String endDate){
        return kuaishouReportDailyAgentSumMapper.companyReport(startDate,endDate);
    }

    //公司报表汇总
    public KuaishouReportDailyAgentSum companyReportSum(String startDate, String endDate){
        return kuaishouReportDailyAgentSumMapper.companyReportSum(startDate, endDate);
    }

    //公司报表详情
    @Override
    public List<KuaishouReportDailyAgent> companyReportAccountDetailList(String date, String advertiserName, Integer isExportNullData){
        return kuaishouReportDailyAgentSumMapper.companyReportAccountDetailList(date, advertiserName, isExportNullData);
    }

    //公司报表详情
    @Override
    public List<KuaishouReportDailyAgent> companyReportAccountDetailListByDateRange(String startDate, String endDate){
        return kuaishouReportDailyAgentSumMapper.companyReportAccountDetailListByDateRange(startDate, endDate);
    }

}
