package cn.com.ctop.kuaishou.modules.utils;

import cn.com.ctop.common.module.utils.Check;

import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.Map;

public class DownloadUtils {


    public static String downloadByUrl(Map<String, Object> requestMap, String downloadPath, String urlStr, String token, String fileName) {

        try {
            StringBuilder postBody = null;
            if (!Check.isNull(requestMap)) {
                postBody = new StringBuilder();
                for (Map.Entry<String, Object> entry : requestMap.entrySet()) {
                    if (entry.getValue() == null) {
                        continue;
                    }
                    postBody.append(entry.getKey()).append("=").append(URLEncoder.encode(entry.getValue().toString(),
                            "utf-8")).append("&");
                }
                if (!requestMap.isEmpty()) {
                    postBody.deleteCharAt(postBody.length() - 1);
                }
            }

            URL url = new URL(urlStr + "?" + postBody);
            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
            //设置超时间为3秒
            conn.setConnectTimeout(120 * 1000);
            //防止屏蔽程序抓取而返回403错误
            conn.setRequestProperty("User-Agent", "Mozilla/4.0 (compatible; MSIE 5.0; Windows NT; DigExt)");
            conn.setRequestProperty("Access-Token", token);
            //得到输入流
            InputStream inputStream = null;

            inputStream = conn.getInputStream();

            //获取自己数组
            byte[] getData = readInputStream(inputStream);

            //文件保存位置
            File saveDir = new File(downloadPath);
            if (!saveDir.exists()) {
                saveDir.mkdirs();
            }
            String filePath = downloadPath + fileName;

            File file = new File(saveDir + File.separator + fileName);
            FileOutputStream fos = new FileOutputStream(file);
            fos.write(getData);
            if (fos != null) {
                fos.close();
            }
            if (inputStream != null) {
                inputStream.close();
            }

            return filePath;
        } catch (IOException e) {
            e.printStackTrace();
        }


        return null;

    }

    public static byte[] readInputStream(InputStream inputStream) throws IOException {
        byte[] buffer = new byte[1024];
        int len = 0;
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        while ((len = inputStream.read(buffer)) != -1) {
            bos.write(buffer, 0, len);
        }
        bos.close();
        return bos.toByteArray();
    }


}
