package cn.com.ctop.bytedance.service.impl;

import cn.com.ctop.bytedance.entity.BytedanceCreativeDailyReport;
import cn.com.ctop.bytedance.mapper.BytedanceCreativeDailyReportMapper;
import cn.com.ctop.bytedance.mapper.MaterialReportMapper;
import cn.com.ctop.bytedance.service.IBytedanceCreativeDailyReportService;
import cn.com.ctop.common.module.utils.Check;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Description: 广告创意日报表信息
 * @Author: jeecg-boot
 * @Date: 2019-09-11
 * @Version: V1.0
 */
@Service
public class BytedanceCreativeDailyReportServiceImpl extends ServiceImpl<BytedanceCreativeDailyReportMapper, BytedanceCreativeDailyReport> implements IBytedanceCreativeDailyReportService {
    @Autowired
    private BytedanceCreativeDailyReportMapper bytedanceCreativeDailyReportMapper;
    @Autowired
    private MaterialReportMapper materialReportMapper;

    @Override
    public List<BytedanceCreativeDailyReport> bytedanceCreativeDailyReportList(JSONObject json) {
        String userId = json.getString("userId");
        String startDate = json.getString("startDate");
        String endDate = json.getString("endDate");
        if (Check.isNull(userId)) {
            return null;
        }
        String roleCode = materialReportMapper.getRoleCodeByUserId(json.getString("userId"));
        if (!"admin".equals(roleCode)) {
            userId = "";
        }

        return bytedanceCreativeDailyReportMapper.bytedanceCreativeDailyReport(userId, startDate, endDate);
    }

    @Override
    public List<BytedanceCreativeDailyReport> bytedanceCreativeAccountReportList(JSONObject json) {
        Map<String, Object> paramsMap = new HashMap<>();
        JSONArray accountIds = json.getJSONArray("accountIds");
        if (Check.isNull(accountIds)) {
            return null;
        }
        List<String> list = JSONObject.parseArray(accountIds.toJSONString(), String.class);
        paramsMap.put("accountIds", list);
        String nowDate = json.getString("startDate");
        String endDate = json.getString("endDate");
        paramsMap.put("startDate", nowDate);
        paramsMap.put("endDate", endDate);

        return bytedanceCreativeDailyReportMapper.bytedanceCreativeAccountReport(paramsMap);
    }

    @Override
    public void replaceBatch(List<BytedanceCreativeDailyReport> dailyReports) {
        bytedanceCreativeDailyReportMapper.replaceBatch(dailyReports);
    }

}
